﻿<%
'///////////////////////////////////////////////////////////////////////////////
'//              Z-Blog
'// 作    者:    朱煊(zx.asd)
'// 版权所有:    RainbowSoft Studio
'// 技术支持:    rainbowsoft@163.com
'// 程序名称:    
'// 程序版本:    
'// 单元名称:    c_system_base.asp
'// 开始时间:    2005.02.11
'// 最后修改:    
'// 备    注:    
'///////////////////////////////////////////////////////////////////////////////


'定义全局变量
Dim objConn

Dim BlogTitle
Dim BlogUser

Dim BlogPath
BlogPath=Server.MapPath("c_system_base.asp")
BlogPath=Left(BlogPath,Len(BlogPath)-Len("c_system_base.asp"))

Dim StarTime
Dim EndTime
StarTime = Timer()

Dim Categorys()
Dim Users()

Dim ArticleList
Dim AuthList
Dim CateList




'*********************************************************
' 目的：    System 初始化
'*********************************************************
Sub System_Initialize()

	On Error Resume Next

	If OpenConnect()=False Then Call ShowError(4)

	Set BlogUser =New TUser

	BlogUser.Verify()

	If Err.Number<>0 Then Call ShowError(10)

End Sub
'*********************************************************




'*********************************************************
' 目的：    System 释放
'*********************************************************
Sub System_Terminate()

	Call CloseConnect()

End Sub
'*********************************************************




'*********************************************************
' 目的：    数据库连接
'*********************************************************
Function OpenConnect()

	'判定是否为子目录调用
	Dim strDbPath
	strDbPath=BlogPath & "/" & ZC_DATABASE_PATH

	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & strDbPath

	OpenConnect=True

End Function
'*********************************************************




'*********************************************************
' 目的：    DB Connect
'*********************************************************
Function CloseConnect()

	objConn.Close
	Set objConn=Nothing

End Function
'*********************************************************




'*********************************************************
' 目的：    时间计长
'*********************************************************
Function RunTime()

	EndTime=Timer()
	RunTime = CStr(CInt(FormatNumber((EndTime-StarTime)*1000,3))) & "ms"

End Function
'*********************************************************




'*********************************************************
' 目的：    分类读取
'*********************************************************
Function GetCategory()

	Dim i
	i=0

	Dim objRS
	Set objRS=objConn.Execute("SELECT * FROM [blog_Category] ORDER BY [cate_Order] ASC,[cate_ID] ASC")

	If (Not objRS.bof) And (Not objRS.eof) Then
		While Not objRS.eof
			ReDim Preserve Categorys(i+1)
			Set Categorys(i)=New TCategory
			Categorys(i).LoadCateInfoByID(objRS("cate_ID"))
			objRS.MoveNext
			i=i+1
		Wend
	End If

	objRS.Close
	Set objRS=Nothing

	GetCategory=True

End Function
'*********************************************************




'*********************************************************
' 目的：    用户读取
'*********************************************************
Function GetUser()

	Dim i
	i=0

	Dim objRS
	Set objRS=objConn.Execute("SELECT * FROM [blog_Member] ORDER BY [mem_ID] ASC")

	If (Not objRS.bof) And (Not objRS.eof) Then
		While Not objRS.eof
			ReDim Preserve Users(i+1)
			Set Users(i)=New TUser
			Users(i).LoadUserInfoByID(objRS("mem_ID"))
			objRS.MoveNext
			i=i+1
		Wend
	End If

	objRS.Close
	Set objRS=Nothing

	Getuser=True

End Function
'*********************************************************




'*********************************************************
' 目的：    Show Calendar
'*********************************************************
Function ShowCalendar(dtmYearMonth)

	If IsEmpty(dtmYearMonth)=False Then
		On Error Resume Next
		Server.Execute("cache/Calendar" & Year(dtmYearMonth) & "-" & Month(dtmYearMonth) & ".asp")
		If Err.Number<>0 then
			Application.Lock
			Response.Write Application(ZC_BLOG_CLSID & "CACHE_CALENDAR")
			Application.UnLock
		End If
		Err.Clear
	Else
		Application.Lock
		Response.Write Application(ZC_BLOG_CLSID & "CACHE_CALENDAR")
		Application.UnLock
	End If

	ShowCalendar=True

End Function
'*********************************************************




'*********************************************************
' 目的：    读取权限
' 备注:     权限最高为1 最低为5 不是则非法
'           "Root"一定只能为1
'           权限配置方式可以变通
'*********************************************************
Function GetRights(strAction)

	Select Case strAction

		Case "login"
			GetRights=5
		Case "verify"
			GetRights=5
		Case "logout"
			GetRights=5
		Case "admin"
			GetRights=4
		Case "cmt"
			GetRights=5
		Case "tb"
			GetRights=5
		Case "vrs"
			GetRights=5
		Case "ArticleMng"
			GetRights=2
		Case "ArticleEdt"
			GetRights=2
		Case "ArticlePst"
			GetRights=2
		Case "ArticleDel"
			GetRights=2
		Case "ArticleBud"
			GetRights=2
		Case "CategoryMng"
			GetRights=1
		Case "CategoryPst"
			GetRights=1
		Case "CategoryDel"
			GetRights=1
		Case "CommentMng"
			GetRights=3
		Case "CommentDel"
			GetRights=3
		Case "TrackBackMng"
			GetRights=2
		Case "TrackBackDel"
			GetRights=2
		Case "TrackBackSnd"
			GetRights=2
		Case "UserMng"
			GetRights=4
		Case "UserEdt"
			GetRights=4
		Case "UserDel"
			GetRights=1
		Case "UserCrt"
			GetRights=1
		Case "BlogReBuild"
			GetRights=3
		Case "FileReBuild"
			GetRights=1
		Case "FileMng"
			GetRights=2
		Case "FileUpload"
			GetRights=2
		Case "FileDel"
			GetRights=2
		Case "Search"
			GetRights=5
		Case "BlogMng"
			GetRights=1
		Case "SettingMng"
			GetRights=1
		Case "SettingSav"
			GetRights=1
		Case "PlugInMng"
			GetRights=1
		Case "rss"
			GetRights=5
		Case "Root"
			GetRights=1

		Case Else Call ShowError(1)

	End Select

End Function
'*********************************************************




'*********************************************************
' 目的：    检查权限
'*********************************************************
Function CheckRights(strAction)

	If BlogUser.Level>GetRights(strAction) Then
		CheckRights=False
	Else
		CheckRights=True
	End If

End Function
'*********************************************************




'*********************************************************
' 目的：    Load List By Cache
'*********************************************************
Function LoadListByCache()

	Dim objStream
	Dim strContent

	If (IsEmpty(Application(ZC_BLOG_CLSID & "CACHE_LIST"))=True) Then
		Application.Lock

		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_LIST.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_LIST")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_CATE.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_CATE")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_AUTH.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_AUTH")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/INCLUDE/calendar.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_CALENDAR")=strContent

		Application.UnLock
	End If

	If (IsEmpty(Application(ZC_BLOG_CLSID & "CACHE_LIST"))=False) Then
		Application.Lock
		ArticleList=Application(ZC_BLOG_CLSID & "CACHE_LIST")
		CateList=Application(ZC_BLOG_CLSID & "CACHE_CATE")
		AuthList=Application(ZC_BLOG_CLSID & "CACHE_AUTH")
		Application.UnLock
	End If

	LoadListByCache=True

End Function
'*********************************************************




'*********************************************************
' 目的：    Parse List
'*********************************************************
Function ParseList(intPage,intCateId,intAuthorId,dtmYearMonth)

	Dim strType
	Dim i
	Dim j
	Dim s
	Dim aryList
	Dim intAllPage

	Call CheckParameter(intPage,"int",1)
	Call CheckParameter(intCateId,"int",Empty)
	Call CheckParameter(intAuthorId,"int",Empty)
	Call CheckParameter(dtmYearMonth,"dtm",Empty)

	If dtmYearMonth<>"" Then
		strType="Date" & CStr(Year(dtmYearMonth) & "-" & Month(dtmYearMonth)) & "Page" & CStr(intPage) & "["
		s="Date" & CStr(Year(dtmYearMonth) & "-" & Month(dtmYearMonth)) & "Page"
	ElseIf intCateID>0 Then
		strType="Cate" & CStr(intCateId) & "Page" & CStr(intPage) & "["
		s="Cate" & CStr(intCateId) & "Page"
	ElseIf intAuthorId>0 Then
		strType="Auth" & CStr(intAuthorId) & "Page" & CStr(intPage) & "["
		s="Auth" & CStr(intAuthorId) & "Page"
	Else
		strType="All" & "Page" & CStr(intPage) & "["
		s="All" & "Page"
	End If

	i=InStrRev(ArticleList,s)
	If i>0 Then
		j=InStr(i,ArticleList,"[",vbBinaryCompare)
		s=Mid(ArticleList,i+Len(s),j-i-Len(s))
		intAllPage=CInt(s)
	Else
		Exit Function
	End If

	i=InStr(1,ArticleList,strType,vbBinaryCompare)
	If i>0 Then
		i=Len(strType)+i
		j=InStr(i,ArticleList,"]",vbBinaryCompare)
		s=Mid(ArticleList,i,j-i)
		aryList=Split(s,";")
	Else
		Exit Function
	End If

	For i=LBound(aryList) To UBound(aryList)-1
		On Error Resume Next
		Server.Execute("cache/" & aryList(i) & ".asp")
		Err.Clear
	Next

	Response.Write ExportBar(intPage,intAllPage,intCateId,intAuthorId,dtmYearMonth)

	ParseList=True

End Function
'*********************************************************
'*********************************************************
Function ExportBar(intNowPage,intAllPage,intCateId,intAuthorId,dtmYearMonth)

	Dim i
	Dim s
	Dim t
	Dim strPageBar
	If Not IsEmpty(intCateId) Then t=t & "cate=" & intCateId & "&amp;"
	If Not IsEmpty(dtmYearMonth) Then t=t & "date=" & Year(dtmYearMonth) & "-" & Month(dtmYearMonth) & "&amp;"
	If Not IsEmpty(intAuthorId) Then t=t & "auth=" & intAuthorId & "&amp;"
	If intAllPage>0 Then
		Dim a,b
		strPageBar=strPageBar & "<div class=""post pagebar"">" & ZC_MSG042 & ": "
		strPageBar=strPageBar & "<a href=""catalog.asp?"& t &"page=1"">[&lt;&lt;]</a> "
		If intAllPage>13 Then
			a=intNowPage
			b=intNowPage+13
			If a>13 Then a=a-1:b=b-1
			If b>intAllPage Then b=intAllPage:a=intAllPage-13
		Else
			a=1:b=intAllPage
		End If
		For i=a to b
			s=s+ "<a href=""catalog.asp?"& t &"page="& i &""">[" & i & "]</a> "
		Next
		strPageBar=strPageBar+s
		strPageBar=strPageBar+ "<a href=""catalog.asp?"& t &"page="& intAllPage &""">[&gt;&gt;]</a> "
		strPageBar=strPageBar+ "</div>"
	End If
	ExportBar=vbCrlf & strPageBar

End Function
'*********************************************************
%>